import { login, logout, getInfo } from '@/api/login';
import { getAreaListApi } from "@/api/common";
import { getToken, setToken, removeToken, setTenantid } from '@/utils/auth';

const user = {
  state: {
    token: getToken(),
    name: '',
    avatar: '',
    roles: [],
    permissions: [],
    userId: '',
    phonenumber: '',
    areaArrayList: []
  },

  mutations: {
    SET_TOKEN: (state, token) => {
      state.token = token;
    },
    SET_NAME: (state, name) => {
      state.name = name;
    },
    SET_AVATAR: (state, avatar) => {
      state.avatar = avatar;
    },
    SET_ROLES: (state, roles) => {
      state.roles = roles;
    },
    SET_PERMISSIONS: (state, permissions) => {
      state.permissions = permissions;
    },
    SET_USERID: (state, userId) => {
      state.userId = userId;
    },
    SET_USERPHONE: (state, phonenumber) => {
      state.phonenumber = phonenumber;
    },
    SET_AREA_LIST(state, payload) {
      state.areaArrayList = payload ? payload : [];
    }
  },

  actions: {
    // 登录
    Login({ commit }, userInfo) {
      const username = userInfo.username.trim();
      const password = userInfo.password;
      const code = userInfo.code;
      const uuid = userInfo.uuid;
      return new Promise((resolve, reject) => {
        login(username, password, code, uuid).then(res => {
          setToken(res.data.token);
          commit('SET_TOKEN', res.data.token);
          setTenantid(res.data.tenantId);
          resolve();
        }).catch(error => {
          reject(error);
        });
      });
    },

    // 获取用户信息
    GetInfo({ commit, state }) {
      return new Promise((resolve, reject) => {
        getInfo().then(res => {
          const user = res.data.user;
          const avatar = user.avatar ? user.avatar : '';
          if (res.data.roles && res.data.roles.length > 0) { // 验证返回的roles是否是一个非空数组
            commit('SET_ROLES', res.data.roles);
            commit('SET_PERMISSIONS', res.data.permissions);
          } else {
            commit('SET_ROLES', ['ROLE_DEFAULT']);
          }
          commit('SET_NAME', user.nickName);
          commit('SET_AVATAR', avatar);
          commit('SET_USERID', user.userId);
          commit('SET_USERPHONE', user.phonenumber);
          resolve(res);
        }).catch(error => {
          reject(error);
        });
      });
    },

    // 获取地区信息
    async getArea({ commit, state }) {
      try {
        const areaList = await getAreaListApi();
        if (areaList.code == 200) {
          commit("SET_AREA_LIST", areaList.data);
          return areaList;
        }
        return [];
      } catch (error) { }
    },

    // 退出系统
    LogOut({ commit, state }) {
      return new Promise((resolve, reject) => {
        logout(state.token).then(() => {
          commit('SET_TOKEN', '');
          commit('SET_ROLES', []);
          commit('SET_PERMISSIONS', []);
          removeToken();
          resolve();
        }).catch(error => {
          reject(error);
        });
      });
    },

    // 前端 登出
    FedLogOut({ commit }) {
      return new Promise(resolve => {
        commit('SET_TOKEN', '');
        removeToken();
        resolve();
      });
    }
  }
};

export default user;
